// scrollingtext.java

// This applet was written by Riad Wahby.
// It is hereby entered into the public domain
// under the provisions of the GNU Public License.
// It may be distributed freely so long as this
// header remains intact. - rsw@mit.edu

import java.applet.Applet;
import java.awt.*;
import java.net.*;
import java.lang.reflect.*;
import java.io.*;

public class jstock extends Applet implements Runnable
{
  // necessary constants
  int MAX_NETWORK_ERRS = 10;
  int MAX_MESSAGE_LENGTH = 3150; // provides enough space for 50 stocks
  char null_char_array[] = {'\0'};
  String NULL_STRING = new String(null_char_array);
			  
  // the text to display
  String line1text, line2text, line3text;

  // font information
  int fontsize;
  Font textFont;
  FontMetrics fontMetrics;

  // information for moving the message
  int stepPixels;
  int oldX, newX, Y1, Y2, Y3;
  int speed;

  // port number
  int portnumber;

  // our thread
  Thread scroller = null;

  // size of our frame
  int width;
  int height;
  int widthofframe;

  // colors
  Color text1Color, text2Color, text3Color, backColor, frameColor;

  // get ticker info?
  boolean DownloadTickerInfo = true;

  // do we have a server name?
  boolean NoServerName = false;

  // number of network errors -- stop downloading
  // if greater than 10
  int network_errors = 0;
 
  public void setColors()
  {
    String text1ColorRed = getParameter("text1ColorRedValue");
    String text1ColorGreen = getParameter("text1ColorGreenValue");
    String text1ColorBlue = getParameter("text1ColorBlueValue");
    String text2ColorRed = getParameter("text2ColorRedValue");
    String text2ColorGreen = getParameter("text2ColorGreenValue");
    String text2ColorBlue = getParameter("text2ColorBlueValue");
    String text3ColorRed = getParameter("text3ColorRedValue");
    String text3ColorGreen = getParameter("text3ColorGreenValue");
    String text3ColorBlue = getParameter("text3ColorBlueValue");
    String backColorRed = getParameter("backColorRedValue");
    String backColorGreen = getParameter("backColorGreenValue");
    String backColorBlue = getParameter("backColorBlueValue");
    String frameColorRed = getParameter("frameColorRedValue");
    String frameColorBlue = getParameter("frameColorBlueValue");
    String frameColorGreen = getParameter("frameColorGreenValue");
    
    if (text1ColorRed == null || text1ColorGreen == null || text1ColorBlue == null)
      {
	text1Color = Color.black;
      }
    else
      {
	int text1ColorRedVal = Integer.parseInt(text1ColorRed);
	int text1ColorGreenVal = Integer.parseInt(text1ColorGreen);
	int text1ColorBlueVal = Integer.parseInt(text1ColorBlue);
	text1Color = new Color(text1ColorRedVal,text1ColorGreenVal,text1ColorBlueVal);
      }
    
    if (text2ColorRed == null || text2ColorGreen == null || text2ColorBlue == null)
      {
	text2Color = Color.black;
      }
    else
      {
	int text2ColorRedVal = Integer.parseInt(text2ColorRed);
	int text2ColorGreenVal = Integer.parseInt(text2ColorGreen);
	int text2ColorBlueVal = Integer.parseInt(text2ColorBlue);
	text2Color = new Color(text2ColorRedVal,text2ColorGreenVal,text2ColorBlueVal);
      }
    
    if (text3ColorRed == null || text3ColorGreen == null || text3ColorBlue == null)
      {
	text3Color = Color.black;
      }
    else
      {
	int text3ColorRedVal = Integer.parseInt(text3ColorRed);
	int text3ColorGreenVal = Integer.parseInt(text3ColorGreen);
	int text3ColorBlueVal = Integer.parseInt(text3ColorBlue);
	text3Color = new Color(text3ColorRedVal,text3ColorGreenVal,text3ColorBlueVal);
      }
    
    if (backColorRed == null || backColorGreen == null || backColorBlue == null)
      {
	backColor = Color.white;
      }
    else
      {
	int backColorRedVal = Integer.parseInt(backColorRed);
	int backColorGreenVal = Integer.parseInt(backColorGreen);
	int backColorBlueVal = Integer.parseInt(backColorBlue);
	backColor = new Color(backColorRedVal,backColorGreenVal,backColorBlueVal);
      }
    
    if (frameColorRed == null || frameColorGreen == null || frameColorBlue == null)
      {
	frameColor = Color.white;
      }
    else
      {
	int frameColorRedVal = Integer.parseInt(frameColorRed);
	int frameColorGreenVal = Integer.parseInt(frameColorGreen);
	int frameColorBlueVal = Integer.parseInt(frameColorBlue);
	frameColor = new Color(frameColorRedVal,frameColorGreenVal,frameColorBlueVal);
      }
  }
  
  public void checkSize()
  {
    int w = size().width;
    int h = size().height;
    if (width != w || height != h)
      {
	width = w;
	height = h;
      }
  }
  
  public void setFont()
  {
    String fontsizeStr = getParameter("fontsize");
    
    if (fontsizeStr == null)
      fontsize = 12;
    else
      fontsize = Integer.parseInt(fontsizeStr);
    
    textFont = new Font("Courier", Font.PLAIN, fontsize);
  }
  
  public void init()
  {
    // get the port number
    String portnumberstring = getParameter("portnumber");
    if (portnumberstring == null)
      {
	line1text = line2text = line3text = "No port number specified.  Please specify the portnumber parameter.";
	NoServerName = true;
      }
    else
      {
	portnumber = Integer.parseInt(portnumberstring);
      }

    // Get the size that we're using.  This _can_ change while the applet runs, so every time
    // we paint, we call it again.
    checkSize();
    
    // Set the colors to use from user input.
    setColors();
    
    // Immediately set the background to get rid of the grey box
    setBackground(backColor);
    
    // Get the speed of the text message from user input.
    String speedStr = getParameter("speed");
    if (speedStr == null)
      speed = 50;
    else
      speed = Integer.parseInt(speedStr);
    
    // Get the frame width from user input.
    String frameStr = getParameter("framewidth");
    if (frameStr == null)
      widthofframe = 0;
    else
      widthofframe = Integer.parseInt(frameStr);
    
    // Get the font info from user input.
    setFont();
    
    stepPixels = 6;
  }
  
  public void start()
  {
    DownloadTickerInfo = true;
    network_errors = 0;
    if (scroller == null)
      {
	scroller = new Thread(this);
	scroller.start();
      }
  }
  
  public void stop()
  {
    if (scroller != null)
      {
	scroller.stop();
	scroller = null;
      }
  }
  
  public void run()
  {
    DownloadTickerInfo = true;
    network_errors = 0;
    Thread.currentThread().setPriority(Thread.NORM_PRIORITY);
    paint(this.getGraphics());
    while(true)
      repaint(speed);
  }
  
  public void getTicker()
  {
    // if we have no server to connect to, or we
    // have had too many network errors, we should
    // return immediately
    if ((! DownloadTickerInfo) || NoServerName)
      return;

    // allocate buffers for the TCP packet data
    byte[] packet_buffer = new byte[MAX_MESSAGE_LENGTH];
    String message_buffer;
    int bytes_read;
    int first_null;
    int second_null;

    // catch exceptions
    try
      {
	// identify the server from which we downloaded
	// the applet
	String servername = this.getCodeBase().getHost();
	
	// create an inetaddress object based on the hostname
	InetAddress remoteserver = InetAddress.getByName(servername);
	
	// bind a local socket
	Socket client_sock = new Socket(remoteserver, portnumber);
	
	// connect to the server
	InputStream client_stream = client_sock.getInputStream();

	// get the points where the strings begin
	bytes_read = client_stream.read(packet_buffer);
	message_buffer = new String(packet_buffer, 0);
	first_null = message_buffer.indexOf(NULL_STRING);
	second_null = message_buffer.indexOf(NULL_STRING, first_null + 1);
	
	// parse out the strings
	line1text = message_buffer.substring(0, first_null);
	line2text = message_buffer.substring(first_null + 1, second_null);
	line3text = message_buffer.substring(second_null + 1, bytes_read - 1);
	
	// close the stream
	client_stream.close();
	
	// close the socket
	client_sock.close();
      }
    catch (NullPointerException e)
      {
	System.out.println("Null pointer exception: " + e.getMessage());
	if (++network_errors > MAX_NETWORK_ERRS)
	  DownloadTickerInfo = false;
	line1text = line2text = line3text = "Network error.";
      }
    catch (UnknownHostException e)
      {
	System.out.println("Unknown host exception: " + e.getMessage());
	if (++network_errors > MAX_NETWORK_ERRS)
	  DownloadTickerInfo = false;
	line1text = line2text = line3text = "Network error.";
      }
    catch (SocketException e)
      {
	System.out.println("Socket Exception: " + e.getMessage());
	if (++network_errors > MAX_NETWORK_ERRS)
	  DownloadTickerInfo = false;
	line1text = line2text = line3text = "Network error.";
      }
    catch (IOException e)
      {
	System.out.println("I/O Exception: " + e.getMessage());
	if (++network_errors > MAX_NETWORK_ERRS)
	  DownloadTickerInfo = false;
	line1text = line2text = line3text = "Network error.";
      }
    finally
      {
	return;
      }
  }
      
  public void paint(Graphics g)
  {
    try
      {
	// get the tickerinfo
	getTicker();
	
	// Make sure the size is correct.
	checkSize();
	
	// Draw the frame, if necessary.
	if (widthofframe != 0)
	  {
	    g.setColor(frameColor);
	    g.fillRect(0,0, width, height);
	  }
	
	// Draw the filled rectangle no matter what.  If no frame, then widthofframe = 0, so this is OK.
	g.setColor(backColor);
	g.fillRect(widthofframe, widthofframe, width - (widthofframe * 2), height - (widthofframe * 2));
	
	g.setFont(textFont);
	fontMetrics = g.getFontMetrics();
	
	// Set initial X and Y to drawString
	oldX = newX = width - fontMetrics.charWidth(line1text.charAt(0));
	Y1 = (height/4) + (fontMetrics.getAscent()/2);
	Y2 = (height/2) + (fontMetrics.getAscent()/2);
	Y3 = (3*height/4) + (fontMetrics.getAscent()/2);
      }
    catch (NullPointerException e)
      {
	System.out.println("Null pointer exception in paint(): " + e.getMessage());
      }
    finally
      {
	return;
      }  
  }
  

  public void update(Graphics g)
  {
    try
      {
	g.setFont(textFont);
	
	// Erase old display
	g.setColor(backColor);
	g.fillRect(widthofframe, widthofframe, width - (widthofframe * 2), height - (widthofframe * 2));
	
	// Draw the new display.
	g.setColor(text1Color);
	g.drawString(line1text, newX, Y1);
	g.setColor(text2Color);
	g.drawString(line2text, newX, Y2);
	g.setColor(text3Color);
	g.drawString(line3text, newX, Y3);
	if (widthofframe != 0)
	  {
	    g.setColor(frameColor);
	    g.fillRect(0, 0, width, widthofframe);
	    g.fillRect(0, 0, widthofframe, height);
	    g.fillRect((width - widthofframe), 0, widthofframe, height);
	    g.fillRect(0, (height - widthofframe), width, widthofframe);
	  }
	
	// Move over a bit.
	oldX = newX;
	newX -= stepPixels;
	
	// should we restart yet?
	int widthofthestring = fontMetrics.stringWidth(line1text);
	int widthofthelastchar = fontMetrics.charWidth(line1text.charAt(line1text.length() - 1));
	
	if (newX <= - (widthofthestring - widthofthelastchar))
	  {
	    paint(g);
	  }
      }
    catch (NullPointerException e)
      {
	System.out.println("Null pointer exception in update(): " + e.getMessage());
      }
    finally
      {
	return;
      }
  }
  
  public String getAppletInfo()
  {
    String messagepart1 = "This applet is a client for a TCP stock server.  It requires\n";
    String messagepart2 = "that the TCP server be running on the machine from which the\n";
    String messagepart3 = "applet was downloaded (because of applet security restrictions\n";
    String messagepart4 = "used by most browsers).\n";
    return (messagepart1 + messagepart2 + messagepart3 + messagepart4); 
  }
  
  public String[][] getParameterInfo()
  {
    String[][] info =
    {
      {"speed", "integer", "scrolling speed (larger = slower)"},
      {"portnumber", "integer", "port number of remote server"},
      {"textXColorRedValue", "integer", "red value of text line X color in decimal (0..255), default 255"},
      {"textXColorBlueValue", "integer", "blue value of text line X color in decimal, default 255"},
      {"textXColorGreenValue", "integer", "green value of text line X color in decimal, default 255"},
      {"backColorRedValue", "integer", "red value of background color in decimal, default 0"},
      {"backColorBlueValue", "integer", "blue value of background color in decimal, default 0"},
      {"backColorGreenValue", "integer", "green value of background color in decimal, default 0"},
      {"frameColorRedValue", "integer", "red value of frame color in decimal, default 255"},
      {"frameColorBlueValue", "integer", "blue value of frame color in decimal, default 255"},
      {"frameColorGreenValue", "integer", "green value of frame color in decimal, default 255"},
      {"framewidth", "integer", "width in pixels of the frame around the display, default 0"},
      {"fontsize", "integer", "size in points of the font, default 12"}
    };
    
    return info;
  }
}

